dofile("scripts/base/util.lua")

if can_read_state() ~= "yes" then
	return text
end

--~ print("automate.lua: ", path)

params = parse_params(params)

if path == "/custom-automate-page" then
	print("params", params)
end

--~ got uri: /inventory.php | ?which=2&action=message (from /inv_equip.php?action=customoutfit&outfitname=kolproxy+backup), size 85883
--~ got uri: /charpane.php |  (from /charpane.php), size 9442
--~ got uri: /account_manageoutfits.php |  (from /account_manageoutfits.php), size 1353
--~ posting page /account_manageoutfits.php params: Just [("action","Yep."),("name2","kolproxy backup"),("delete2","on")]

if path == "/lair6.php" then
	if params.place == "0" then
		if string.match(text, "At the top of the steps leading to the Sorceress' Chamber, you encounter two doors.") then
			code = set_ascension_state("zone.lair.doorcode", "")
			post_page("/lair6.php", { preaction = "lightdoor" })
			code = get_ascension_state("zone.lair.doorcode")
			print("lair6 code", code, "params", table_to_str(params))
			if code ~= "" then
				text = post_page("/lair6.php", { action = "doorcode", code = code })
			end
		end
	end
	if params.place == "3" or params.place == "4" then
		if string.match(text, "Disappointed by your failure, you stomp off in a huff, and stub your toe.") then
			which = string.match(text, [[<img src="http://images.kingdomofloathing.com/adventureimages/([a-z]+).gif" width=100 height=100>]])
			print("Sorceress familiar:", which)
			local familiar_lookup = {
				barrrnacle = { id = 4, name = "Angry Goat", },
				goat = { id = 1, name = "Mosquito", },
				lime = { id = 3, name = "Levitating Potato", },
				mosquito = { id = 5, name = "Sabre-Toothed Lime", },
				potato = { id = 8, name = "Barrrnacle", },
			}
			if familiar_lookup[which] then
				status = str_to_table(get_status_info())
				get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(familiar_lookup[which].id) })
				set_session_state("lair6.familiar.need", tostring(familiar_lookup[which].name))
				newstatus = str_to_table(get_status_info())
				weight = nil -- TODO: hack!
				if tonumber(newstatus.familiar) == familiar_lookup[which].id then
					if weight and weight >= 20 then
						newtext = get_page("/lair6.php", { place = params.place })
						if string.match(newtext, "You move further into the tower, while huge chunks of stone fall from the walls for no good reason.") then
							set_session_state("lair6.familiar.result", "won")
							text = newtext
							print("Won vs NS familiar")
						else
							set_session_state("lair6.familiar.result", "error")
							text = newtext .. "<br><br>Error, expected to win this fight with a " .. tostring(weight) .. " lb " .. familiar_lookup[which].name .. "."
							print("Error fighting NS familiar")
						end
					else
						set_session_state("lair6.familiar.result", "too low weight")
						print("Familiar weight is only", weight)
					end
				else
					set_session_state("lair6.familiar.result", "missing")
					print("Missing familiar")
				end
				get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = status.familiar })
			else
				print("Unknown NS familiar", which)
			end
		end
	end
end

if path == "/mystic.php" then
	if string.match(text, "Would you like to hear a tale") then
		post_page("/mystic.php", { action = "crackyes1" })
		post_page("/mystic.php", { action = "crackyes2" })
		text = post_page("/mystic.php", { action = "crackyes3" })
	end
end


--~ >The Oracle speaks:<p>&quot;Your Major Consultation is this:  That plus sign you've been hanging on to?  It's actually a book.  Read it.&quot;<

--~ itemid[818]
--~ got uri: /inv_use.php | ?pwd=060d42221ac94e9d872f39c247195466&which=3&whichitem=818&ajax=1&_=1270355701308 (from /inv_use.php?pwd=060d42221ac94e9d872f39c247195466&which=3&whichitem=818&ajax=1&_=1270355701308), size 1041

if path == "/choice.php" then
	if requestpath == "/inv_use.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name == "Orcish Frat House blueprints" then -- prevent use if you don't have the stuff?
			local inventory = str_to_table(get_inventory_counts())
			options = {
				[1] = { wearing = { hat = "Orcish baseball cap", weapon = "homoerotic frat-paddle", pants = "Orcish cargo shorts" } },
				[2] = { wearing = { hat = "mullet wig" }, inventory = { name = "briefcase", amount = 1 } },
				[3] = { wearing = { pants = "frilly skirt" }, inventory = { name = "hot wing", amount = 3 } },
			}
			local buyable = { ["frilly skirt"] = true }
			function check_option(tbl, equipment)
				local equipped = true
				local possible = true
				for where, want in pairs(tbl.wearing) do
					local have = equipment[where] and str_to_table(get_item_data_by_id(equipment[where])).name
					if have ~= want then
						equipped = false
						local itemid = tonumber(str_to_table(get_item_data_by_name(want)).id)
						if not (inventory[itemid] or buyable[want]) then possible = false end
					end
				end
				if tbl.inventory then
					local itemid = tonumber(str_to_table(get_item_data_by_name(tbl.inventory.name)).id)
					if not (inventory[itemid] and inventory[itemid] >= tbl.inventory.amount) then
						possible = false
					end
				end
				return possible, equipped
			end
			function equip_for_option(tbl, equipment)
				local changed = {}
				for where, want in pairs(tbl.wearing) do
					local have = equipment[where] and str_to_table(get_item_data_by_id(equipment[where])).name
					if have ~= want then
						local itemid = tonumber(str_to_table(get_item_data_by_name(want)).id)
						if buyable[want] then
							if not inventory[itemid] then
								get_page("/store.php", { phash = params.pwd, buying = "1", whichitem = tostring(itemid), howmany = "1", whichstore = "5", ajax = "1", action = "buyitem" })
							end
						end
						get_page("/inv_equip.php", { pwd = params.pwd, action = "equip", whichitem = tostring(itemid), ajax = "1" })
						changed[where] = equipment[where]
					end
				end
				return changed
			end
			function do_infiltrationist()
				local equipment = str_to_table(str_to_table(get_status_info()).equipment)
				for choicenum, tbl in pairs(options) do
					possible, equipped = check_option(tbl, equipment)
					if possible and equipped then
						text = post_page("/choice.php", { pwd = params.pwd, whichchoice = tostring(188), option = tostring(choicenum)})
						text = text:gsub([[<a href="adventure.php%?snarfblat=27">Adventure Again %(The Orcish Frat House%)</a>]], "")
						return
					end
					if possible then
						print("equip up for", choicenum)
						local changed = equip_for_option(tbl, equipment)
						local newequipment = str_to_table(str_to_table(get_status_info()).equipment)
						possible, equipped = check_option(tbl, newequipment)
						if possible and equipped then
							text = post_page("/choice.php", { pwd = params.pwd, whichchoice = tostring(188), option = tostring(choicenum)})
							text = text:gsub([[<a href="adventure.php%?snarfblat=27">Adventure Again %(The Orcish Frat House%)</a>]], "")
						end
						for x, itemid in pairs(changed) do
							get_page("/inv_equip.php", { pwd = params.pwd, action = "equip", whichitem = tostring(itemid), ajax = "1" })
						end
						return
					end
				end
			end
			do_infiltrationist()
--~ 			post_page("/choice.php", { pwd = params.pwd, whichchoice = 188, option = 3})
		end
	end
end

local function plunge_items(a, b, pwd)
	local aid = tonumber(str_to_table(get_item_data_by_name(a)).id)
	local bid = tonumber(str_to_table(get_item_data_by_name(b)).id)
	post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = tostring(aid), item2 = tostring(bid), quantity = "1", ajax = "1" })
end

if path == "/beach.php" then
	if params.action == "woodencity" then
		if text:match("commence to getting that staff") then
			local pwd = get_session_state("pwd") -- careful!
			plunge_items("ancient amulet", "Eye of Ed", pwd)
			plunge_items("ancient amulet", "Staff of Fats", pwd)
			plunge_items("Staff of Fats", "headpiece of the Staff of Ed", pwd)
			plunge_items("Eye of Ed", "Staff of Ed, almost", pwd)
			text = post_page("/beach.php", params)
		end
	end
end

if path == "/leaflet.php" then
	if params.justgothere == "yes" then
		if text:match("You are standing in an open field west of a white house.") then
			local function pp(cmds)
				local pwd = get_session_state("pwd") -- inserting pwd, boo!
				local t = nil
				for _, c in pairs(cmds) do
					t = post_page("/leaflet.php", { pwd = pwd, command = cmd })
				end
				return t
			end
			pp { "open door", "east", "take sword", "look at tinder", "take parchment" }
			local manteltext, manteluri = pp { "look at mantel" }
			local magic_words = {
				["small brick building"] = "plugh",
				["model ship inside a bottle"] = "yoho",
				["carved driftwood bird"] = "plover",
				["small white house"] = "xyzzy",
			}
			local magic = nil
			for a,b in pairs(magic_words) do
				if manteltext:match(a) then
					magic = b
				end
			end
			if magic == nil then
				text = manteltext
			else
				print("the magic word is", magic)
				pp { magic }
				pp { "west", "north", "take stick", "cut hedge", "west", "light stick", "east" }

				pp { "north", "kill snake", "open chest", "look behind chest", "look in hole", "south", "south" }

				pp { "east", "light fire", "take boots", "wear boots", "west" }

				pp { "south", "south" }
				pp { "south", "south" }

				for i = 1, 10 do
					pp { "north", "west", "east", "south" }
				end

				pp { "up", "take egg", "throw egg at roadrunner", "down" }
				pp { "move leaves", "up", "throw ruby at bowl" }
				pp { "gnusto cleesh", "up", "cleesh giant", "take ring", "win game" }
				text = pp { "exit" }

				text = [[<script type="text/javascript">top.charpane.location.href="charpane.php";</script>]] .. text
			end
		end
	end
end

mode = "automate"
dofile("scripts/ascension.lua")
dofile("scripts/nemesis-automation.lua")
dofile("scripts/ascension-automation.lua")
dofile("scripts/spading-automation.lua")

return text
