io = nil
os = nil
debug = nil
require = nil
module = nil
package = nil

--~ print("\n\n\n\n")
--~ print(text)
--~ print("\n\n\n\n")

if can_read_state() ~= "yes" then
	return text
end

dofile("scripts/base/util.lua")

input_params = params
params = parse_params(params)

--~ print("pt", path, text)

function query_to_table(str)
	local tbl = {}
	for a, b in string.gmatch(str, "([a-z]+)=([A-Za-z0-9]+)") do
		tbl[a] = b
	end
	return tbl
end

--~ params = query_to_table(query)
--~ requestparams = query_to_table(requestquery)

local processors = {}
local printers = {}
noncombat_choice_texts = {}

local function add_processor_raw(scriptname, file, func)
	if not processors[file] then processors[file] = {} end
	table.insert(processors[file], { scriptname = scriptname, f = func })
end

local function add_printer_raw(scriptname, file, func)
	if not printers[file] then printers[file] = {} end
	table.insert(printers[file], { scriptname = scriptname, f = func })
end

local function add_choice_text_conditional_raw(scriptname, title, data, test)
	if not noncombat_choice_texts[title] then noncombat_choice_texts[title] = {} end
	table.insert(noncombat_choice_texts[title], { test = test, data = data, scriptname = scriptname })
end

-- Fake custom combat skill functions

--~ function register_combat_skill(name, f, auto) end
--~ function add_simple_custom_combat_skill(name, list, auto) end


function load_file(category, name)
	add_processor = function (file, func) add_processor_raw(name, file, func) end
	add_printer = function (file, func) add_printer_raw(name, file, func) end
	add_choice_text_conditional = function (title, tbl, func) add_choice_text_conditional_raw(name, title, tbl, func) end
	add_choice_text = function (title, tbl) add_choice_text_conditional_raw(name, title, tbl, function() return true end) end
	add_choice_itemtext = function (title, tbl) add_choice_text_conditional_raw(name, title, tbl, function() return true end) end
	add_choice_function = function (title, f) add_choice_text_conditional_raw(name, title, f, function() return true end) end
	if category ~= "chat" then
		dofile("scripts/"..name)
	end
	add_processor = nil
	add_printer = nil
	add_choice_text_conditional = nil
	add_choice_text = nil
	add_choice_itemtext = nil
end

if path == "/charpane.php" then
	familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0></a><br>([0-9]+) lb")
	if not familiar_picture then
		familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0>.- <b>([0-9]+)</b> pound ") -- TODO-future: redo without .-?
	end
	familiar_weight = tonumber(familiar_weight)
end

if active and path == "/charpane.php" then
	text = string.gsub(text, "(<td align=right>Meat:.-)(</table>)", "%1<!-- charpane compact text space -->%2")
	text = string.gsub(text, "(src=\"http://images.kingdomofloathing.com/itemimages/hourglass.gif\".-</table>.-<br>)", "%1<!-- charpane normal text space -->")

	text = string.gsub(text, "(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0></a><br>)([0-9]+)( lb.-)(</center>)", "%1%2%3%4%5<!-- charpane compact familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-?
	text = string.gsub(text, "(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0>.- <b>)([0-9]+)(</b> pound .-)(</table></center>)", "%1%2%3%4%5<!-- charpane normal familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-!
end





-- Fullness and spleen --

if not active then

	function eaten_food(item, usetext)
		for x in (usetext .. "<p><center><b>and then...</b></center></p>"):gmatch("(.-)<p><center><b>and then%.%.%.</b></center></p>") do
			if x:match([[<img src="http://images.kingdomofloathing.com/itemimages/[^"]-%.gif" width=30 height=30>]]) then
				if not x:match(">You're too full to") then
					print("ate food", printstr(item), x)
					if tonumber(item.fullness) then
						increase_daily_counter("fullness", tonumber(item.fullness))
					else
						set_day_state("unknown fullness", "yes")
					end
				end
			end
		end
	end

	function used_spleen(item, quantity, usetext)
		if not usetext:match("bad for your spleen.  That .- would cause it to rupture.<") then
			print("used spleen", quantity, printstr(item), usetext)
			if tonumber(item.spleen) then
				increase_daily_counter("spleen", tonumber(item.spleen) * quantity)
			else
				set_day_state("unknown spleen", "yes")
			end
		end
	end

	if path == "/inv_eat.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name then
			eaten_food(d, text)
		else
			set_day_state("unknown fullness", "yes")
			local tbl = get_ascension_state("unknown food items eaten")
			if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
			table.insert(tbl, params.whichitem)
			set_ascension_state("unknown food items eaten", table_to_str(tbl))
		end
	end

	--~ posting page /sushi.php params: Just [("action","Yep."),("pwd","bc24379b44f024724b28de075dd2f860"),("whichsushi","5"),("whichtopping","3819"),("whichfilling1","0")]
	--~ got uri: /sushi.php |  (from /sushi.php), size 3698

	if path == "/inv_use.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name then
			if d.spleen then
				local amount = tonumber(params.itemquantity) or 1
				used_spleen(d, amount, text)
			end
		else
			set_day_state("unknown spleen", "yes")
			local tbl = get_ascension_state("unknown spleen items used")
			if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
			table.insert(tbl, params.whichitem)
			set_ascension_state("unknown spleen items used", table_to_str(tbl))
		end
	end

	if path == "/multiuse.php" then
		local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
		if d.name then
			if d.spleen then
				used_spleen(d, tonumber(params.quantity), text)
			end
		else
			set_day_state("unknown spleen", "yes")
		end
	end

	if path == "/inventory.php" then
		if requestpath == "/inv_eat.php" then
			local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
			if d.name then
				eaten_food(d, text:match([[<div id="effdiv">.-</div>]]))
			else
				set_day_state("unknown fullness", "yes")
			end
		end
		if requestpath == "/inv_use.php" then
			local d = str_to_table(get_item_data_by_id(tonumber(params.whichitem)))
			if d.name then
				if d.spleen then
					used_spleen(d, 1, text:match([[<div id="effdiv">.-</div>]]))
				end
			else
				set_day_state("unknown spleen", "yes")
			end
		end
	end

end

-- /Fullness and spleen --





dofile("scripts/loaders.lua")

if not active then
	if requestpath == "/adventure.php" then
		zone = string.match(requestquery, "snarfblat=([0-9]+)")
-- 		print("setting zone", zone)
		if (zone) then
			set_fight_state("zone", tonumber(zone))
			set_ascension_state("adventure.lastzone", tonumber(zone))
		end
	end
end




for x in text:gmatch("var onturn = ([0-9]+);") do
	combat_round = tonumber(x)
end
monster_name = string.match(text, "<span id='monname'>(.-)</span>")
if path == "/fight.php" then
	local z = get_fight_state("zone")
	if z ~= "" then
		adventure_zone = tonumber(z)
	end
end

adventure_title = string.match(text, [[<tr><td style="color: white;" align=center bgcolor=blue><b>([^<]*)</b></td></tr>]])
choice_adventure_number = tonumber(string.match(text, [[<input type=hidden name=whichchoice value=([0-9]+)>]]))
adventure_result = string.match(text, [[<td style="color: white;" align=center bgcolor=blue><b>Adventure Results:</b></td></tr><tr><td style="padding: 5px; border: 1px solid blue;"><center><table><tr><td><center><b>([^<]*)</b>]])


fight_is_over = nil
if path == "/fight.php" then
	if (string.match(text, "state%['fightover'%] = true;")) then
		fight_is_over = true
	else
		fight_is_over = false
	end
end

function run_functions(target, pagetext)
	local orig_text = text
	text = pagetext

	if not active then
		for _, processor in pairs(processors[target] or {}) do
			local realtext = text
			processor.f()
			text = realtext
		end
	else
		for _, printer in pairs(printers[target] or {}) do
			printer.f()
		end
	end
	ret_text = text
	text = orig_text
	return ret_text
end

text = run_functions(path, text)

if path == "/fight.php" then
	text = string.gsub(text, [[(<td valign=center><img src="http://images.kingdomofloathing.com/itemimages/)([^"]+.gif)(" width=30 height=30 alt="[^"]+" title=")([^"]+)("></td><td valign=center>)(.-)(</td></tr>)]], function (pre, itemimage, mid, title, td, msg, post)
--~ 		print("item use", msg)
		item_image = itemimage
		item_name = title
		msg = run_functions("used combat item", msg)
		item_image = nil
		item_name = nil
		return pre .. itemimage .. mid .. title .. td .. msg .. post
	end)
end

if path == "/fight.php" then
	text = string.gsub(text, "(<center><table class=\"item\" style=\"float: none\" rel=\")([^\"]*)(\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]+.gif)(\" alt=\"[^\"]*\" title=\")([^\"]*)(\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>)(You acquire .-)(</td></tr></table></center>)", function (pre, rel, mid1, image, mid2, title, mid3, dropinfo, post)
--~ 		print("item capture", pre, rel, mid, dropinfo, post)
		item_image = image
		item_name = title
		msg = run_functions("item drop", dropinfo)
-- 		print("item capture", pre, rel, mid, dropinfo, post)
--~ 		local msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span>" .. post
--~ 		if string.match(rel, "u=u") then
--~ 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [use]" .. post
--~ 			http://localhost:18481/inv_use.php?pwd=xxx&which=3&whichitem=3236
--~ 		elseif string.match(rel, "u=q") then
--~ 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [equip]" .. post
--~ 			http://localhost:18481/inv_equip.php?pwd=xxx&which=2&action=equip&whichitem=2813
--~ 		end
		return pre .. rel .. mid1 .. image .. mid2 .. title .. mid3 .. msg .. post
	end)
end

if path == "/fight.php" then
--~ 	if (string.match(text, "<!%-%-familiarmessage%-%-><center><table>(.-)</table></center>")) then -- TODO-future: redo using commong familiar action event
	text = text:gsub([[(<!%-%-familiarmessage%-%-><center><table>(.-)</table></center>)]], function (msg)
		familiarmessage_picture = msg:match([[<!%-%-familiarmessage%-%-><center><table><tr><td align=center valign=center><img src="http://images.kingdomofloathing.com/itemimages/([^"]+).gif" width=30 height=30></td>]])
		if familiarmessage_picture then
			msg = run_functions("familiar message: " .. familiarmessage_picture, msg)
		end
		msg = run_functions("familiar message", msg)
		return msg
	end)
end

--~ if not active and path == "/fight.php" then
--~ 	setup_combat_skills()
--~ end

if not active and fight_is_over == true then
	reset_fight_state()
end

if active and path == "/charpane.php" then
	print_charpane_lines()
end

--~ if path ~= "/charpane.php" then
--~ 	print(text)
--~ end

return text
